package org.example;

public class Main {
    public static int jumpMinSteps(int[] arr) {
        int n = arr.length;
        if (n <= 1) {
            return 0;
        }

        int maxRange = arr[0]; // 当前位置能跳跃到的最远位置
        int end = arr[0]; // 当前跳跃能到达的边界
        int steps = 1; // 跳跃步数

        for (int i = 1; i < n; i++) {
            if (i > end) {
                // 需要进行一次新的跳跃
                steps++;
                end = maxRange;
            }

            if (arr[i] + i > maxRange) {
                // 更新当前能跳跃到的最远位置
                maxRange = arr[i] + i;
            }
        }

        return steps;
    }
    public static void main(String[] args) {
        int[] arr = {3, 4, 2, 1, 1, 3, 3, 1, 1};
        int result = jumpMinSteps(arr);
        System.out.println("最小步数: " + result);
    }
}
